﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace proba
{
    public partial class EmployeeUpdate : Form
    {
        string id_employee;
        DataBase dataBase = new DataBase();
        public EmployeeUpdate(string id_employee, string surname, string name, string patronymic, string pol, string date_of_birth, string phone, string login)
        {
            InitializeComponent();
            // TODO: данная строка кода позволяет загрузить данные в таблицу "vINILDataSet_Pol.Pol". При необходимости она может быть перемещена или удалена.
            this.polTableAdapter.Fill(this.vINILDataSet_Pol.Pol);
            dataBase.openConnection();
            this.surname.Text = surname;
            this.name.Text = name;
            this.patronymic.Text = patronymic;
            text_id_pol.Text = pol;
            this.date_of_birth.Text = date_of_birth;
            this.phone.Text = phone;
            PoleReg1.Text = login;
            this.id_employee = id_employee;
            dataBase.closeConnection();
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            Employee employee = new Employee();
            employee.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button_save_Click(object sender, EventArgs e)
        {
            string sqccommand_pol = $"SELECT id_pol From Pol WHERE pol = '{text_id_pol.Text}'";
            SqlDataAdapter sda = new SqlDataAdapter(sqccommand_pol, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count == 0) MessageBox.Show("Поле пол должно быть выбрано из списка");
            else if (surname.Text.Replace(" ", "") == "") MessageBox.Show("Поле фамилия не может быть пустым");
            else if (name.Text.Replace(" ", "") == "") MessageBox.Show("Поле имя не может быть пустым");
            else if (patronymic.Text.Replace(" ", "") == "") MessageBox.Show("Поле отчество не может быть пустым");
            else if (text_id_pol.Text.Replace(" ", "") == "") MessageBox.Show("Поле пол не может быть пустым");
            else if (date_of_birth.Text.Replace(" ", "") == "") MessageBox.Show("Поле дата рождения не может быть пустым");
            else if (phone.Text.Replace(" ", "") == "") MessageBox.Show("Поле телефон не может быть пустым");
            else if (PoleReg1.Text.Replace(" ", "") == "") MessageBox.Show("Поле логин не может быть пустым");
            else if (PoleReg1.TextLength > 15) MessageBox.Show("Максимальная длина логина – 15 символов");
            else
            {
                dataBase.openConnection();
                SqlCommand sqlCommand_pol = new SqlCommand(sqccommand_pol, dataBase.GetConnection());
                var id_pol = sqlCommand_pol.ExecuteScalar().ToString();
                var addQuery = $"update Employee set surname = '{surname.Text}', name = '{name.Text}', patronymic = '{patronymic.Text}', id_pol = '{id_pol}', date_of_birth = '{date_of_birth.Text}', phone = '{phone.Text}', login = '{PoleReg1.Text}' where id_employee = '{id_employee}'";
                var command = new SqlCommand(addQuery, dataBase.GetConnection());
                command.ExecuteNonQuery();
                MessageBox.Show("Запись успешно изменена");
                dataBase.closeConnection();
                this.Hide();
                Employee employee = new Employee();
                employee.ShowDialog();
            }
        }

        private void button_password_Click(object sender, EventArgs e)
        {
            this.Hide();
            PasswordChange_Admin passwordChange = new PasswordChange_Admin(id_employee, surname.Text, name.Text, patronymic.Text, text_id_pol.Text, date_of_birth.Text, phone.Text, PoleReg1.Text);
            passwordChange.ShowDialog();
        }
    }
}
