﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Text.RegularExpressions;

namespace proba
{
    public partial class PasswordChange_Admin : Form
    {
        string id_employee;
        string surname;
        string name;
        string patronymic;
        string pol;
        string date_of_birth;
        string phone;
        string login;
        DataBase dataBase = new DataBase();
        Regex rg = new Regex("^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)(?=.*[^\\da-zA-Z]).{8,15}$");
        
        public PasswordChange_Admin(string id_employee, string surname, string name, string patronymic, string pol, string date_of_birth, string phone, string login)
        {
            InitializeComponent();
            this.id_employee = id_employee;
            this.surname = surname;
            this.name = name;
            this.patronymic = patronymic;
            this.pol = pol;
            this.date_of_birth = date_of_birth;
            this.phone = phone;
            this.login = login;
        }

        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            EmployeeUpdate employeeUpdate = new EmployeeUpdate(id_employee, surname, name, patronymic, pol, date_of_birth, phone, login);
            employeeUpdate.ShowDialog();
        }

        private void button_save_Click(object sender, EventArgs e)
        {
            string pass = text_password2.Text;
            if (text_password2.Text.Replace(" ", "") == "") MessageBox.Show("Новый пароль не введён");
            else if (text_password3.Text.Replace(" ", "") == "") MessageBox.Show("Новый пароль не потверждён");
            else if (text_password2.Text == text_password3.Text)
            if (rg.IsMatch(pass))
            {
                var confirmResult = MessageBox.Show("Вы точно хотите изменить пароль?", "Подтвердите изменение!", MessageBoxButtons.YesNo);
                if (confirmResult == DialogResult.Yes)
                {
                    dataBase.openConnection();
                    Shifr.phraze = text_password2.Text;
                    Shifr myTeloInfo1 = new Shifr();
                    myTeloInfo1.ShifrCode();
                    string password_2 = "";
                    for (int i = 0; i < Shifr.codePhraze.Length; i++)
                    {
                        password_2 = password_2 + Shifr.codePhraze[i];
                    }
                    var addQuery = $"update Employee set password = '{password_2}' where login = '{login}'";
                    var command = new SqlCommand(addQuery, dataBase.GetConnection());
                    command.ExecuteNonQuery();
                    MessageBox.Show("Пароль успешно изменён");
                    dataBase.closeConnection();
                    this.Hide();
                    EmployeeUpdate employeeUpdate = new EmployeeUpdate(id_employee, surname, name, patronymic, pol, date_of_birth, phone, login);
                    employeeUpdate.ShowDialog();
                }
            }
            else
            {
                MessageBox.Show("Пароль не соответствует требованиям!");
            }
            else
            {
                MessageBox.Show("Пароли не совпадают!!!");
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                text_password2.UseSystemPasswordChar = false;
            }
            else
            {
                text_password2.UseSystemPasswordChar = true;
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked)
            {
                text_password3.UseSystemPasswordChar = false;
            }
            else
            {
                text_password3.UseSystemPasswordChar = true;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Внимание! используйте только указанные символы. Пароль для регистрации в приложении должен содержать:\n \t 1. A-Z: хотя бы одну заглавную латинскую букву." +
              "\n\t 2. a-z: хотя бы одну строчную латинскую букву. \n\t 3. 8-15 символов \n\t 4. 0-9: одну или несколько цифр \n\t 5. !?@$#%_*=() минимум один спец символ");
        }
    }
}
