﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using proba;
using System;

namespace UnitTestVinil
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void a1_GetCountBuyProducts_return2() // успешное прохождение теста
        {
            int a = 1;
            int expected = 2;
            int act = BuyTools.GetCountBuyProducts(a);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a1_GetCountBuyProducts_return3() // не успешное прохождение теста
        {
            int a = 1;
            int expected = 3;
            int act = BuyTools.GetCountBuyProducts(a);
            Assert.AreEqual(expected, act);
        }
        ///////////////////////////
        [TestMethod]
        public void a5000_b2000_GetSummaBuyProducts_return7000() // успешное прохождение теста
        {
            int a = 5000; // summabuyproducts
            int b = 2000;// summa
            int expected = 7000;
            int act = (int)BuyTools.GetSummaBuyProducts(a, b);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a4000_b6000_GetSummaBuyProducts_return9000() // не успешное прохождение теста
        {
            int a = 4000; // summabuyproducts
            int b = 6000;// summa
            int expected = 9000;
            int act = (int)BuyTools.GetSummaBuyProducts(a, b);
            Assert.AreEqual(expected, act);
        }
        ///////////////////////////
        [TestMethod]
        public void a50000_b5_ShareCount_return47500() // успешное прохождение теста
                                                       // подсчет суммы с учетом скидки в 5 процентов
        {
            int a = 50000; // summa
            int b = 5;// percent
            int expected = 47500;
            double act = BuyTools.ShareCount(a, b);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a50000_b10_ShareCount_return40000() // не успешное прохождение теста
        {
            int a = 50000; // summa
            int b = 10;// percent
            int expected = 40000;
            double act = (double)BuyTools.ShareCount(a, b);
            Assert.AreEqual(expected, act);
        }
        ///////////////////////////
        [TestMethod]
        public void a149675_b29532_GetSurrender_return120143() // успешное прохождение теста

        {
            int a = 29532; // summaProduct
            int b = 149675 ;// summaCustomer
            int expected = 120143;
            double act = BuyTools.GetSurrender(a, b);
            Assert.AreEqual(expected, act);
        }
        [TestMethod]
        public void a550000_b295032_GetSurrender_return154904() // не успешное прохождение теста
        {
            int a = 295032; // summaCustomer
            int b = 550000;// summaProduct
            int expected = 154904;
            double act = (double)BuyTools.GetSurrender(a, b);
            Assert.AreEqual(expected, act);
        }
        ///////////////////////////
        [TestMethod]
        public void a5_GetSumma_return10() // успешное прохождение теста

        {
            double[] a = new double[5]; // 

            double expected = 10;
            for (int i = 0; i < a.Length; i++)
            {
                a[i] = i;
               
            }
            double act = SummaSaleDay.GetSumma(a);
            Assert.AreEqual(expected, act);

        }
        [TestMethod]
        public void a10_GetSumma_return50() // не успешное прохождение теста
        {
            double[] a = new double[10]; // 

            double expected = 50;
            for (int i = 0; i < a.Length; i++)
            {
                a[i] = i;

            }
            double act = SummaSaleDay.GetSumma(a);
            Assert.AreEqual(expected, act);
        }




    }
}
